"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _wrapNativeSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapNativeSuper"));

var _marked =
/*#__PURE__*/
_regenerator.default.mark(flatten);

Object.defineProperty(exports, "__esModule", {
  value: true
});

var Iterator_1 = require("../Iterator");

function createArrayClass(Smbl) {
  /**
   * 这个是对Array的封装
   * 为什么要这么做，请看issue：https://github.com/IAIAE/estime/issues/5
   */
  // @ts-ignore
  var MyArray =
  /*#__PURE__*/
  function (_Array) {
    (0, _inheritsLoose2.default)(MyArray, _Array);

    function MyArray() {
      return _Array.apply(this, arguments) || this;
    }

    MyArray.isArray = function isArray(val) {
      return val instanceof MyArray;
    } // 一个沙箱env初始化后，会分配一个Smbl，用这个方法传给MyArray。一些实例方法(entries等)会用到
    ;

    MyArray._setSmbl = function _setSmbl(Smbl) {
      this._Smbl = Smbl;
    };

    MyArray.of = function of() {
      return MyArray.prototype.slice.call(arguments);
    };

    return MyArray;
  }((0, _wrapNativeSuper2.default)(Array));

  MyArray.from = function () {
    var toStr = Object.prototype.toString;

    var isCallable = function isCallable(fn) {
      return typeof fn === 'function' || toStr.call(fn) === '[object Function]';
    };

    var toInteger = function toInteger(value) {
      var number = Number(value);

      if (isNaN(number)) {
        return 0;
      }

      if (number === 0 || !isFinite(number)) {
        return number;
      }

      return (number > 0 ? 1 : -1) * Math.floor(Math.abs(number));
    };

    var maxSafeInteger = Math.pow(2, 53) - 1;

    var toLength = function toLength(value) {
      var len = toInteger(value);
      return Math.min(Math.max(len, 0), maxSafeInteger);
    }; // The length property of the from method is 1.


    return function from(arrayLike
    /*, mapFn, thisArg */
    ) {
      // 2. Let items be ToObject(arrayLike).
      var items = Object(arrayLike); // 3. ReturnIfAbrupt(items).

      if (arrayLike == null) {
        throw new TypeError('Array.from requires an array-like object - not null or undefined');
      } // 4. If mapfn is undefined, then let mapping be false.


      var mapFn = arguments.length > 1 ? arguments[1] : void undefined;
      var T;

      if (typeof mapFn !== 'undefined') {
        // 5. else
        // 5. a If IsCallable(mapfn) is false, throw a TypeError exception.
        if (!isCallable(mapFn)) {
          throw new TypeError('Array.from: when provided, the second argument must be a function');
        } // 5. b. If thisArg was supplied, let T be thisArg; else let T be undefined.


        if (arguments.length > 2) {
          T = arguments[2];
        }
      } // 10. Let lenValue be Get(items, "length").
      // 11. Let len be ToLength(lenValue).


      var len = toLength(items.length); // 13. If IsConstructor(C) is true, then
      // 13. a. Let A be the result of calling the [[Construct]] internal method
      // of C with an argument list containing the single item len.
      // 14. a. Else, Let A be ArrayCreate(len).

      var A = new MyArray(len); // 16. Let k be 0.

      var k = 0; // 17. Repeat, while k < len… (also steps a - h)

      var kValue;

      while (k < len) {
        kValue = items[k];

        if (mapFn) {
          A[k] = typeof T === 'undefined' ? mapFn(kValue, k) : mapFn.call(T, kValue, k);
        } else {
          A[k] = kValue;
        }

        k += 1;
      } // 18. Let putStatus be Put(A, "length", len, true).


      A.length = len; // 20. Return A.

      return A;
    };
  }();

  Object.defineProperty(MyArray.prototype, '__nativeNewFunc', {
    value: function value(name, args) {
      return Array.prototype[name].apply(this, args);
    },
    enumerable: false,
    configurable: true,
    writable: false
  });
  Object.defineProperty(MyArray.prototype, '__nativeFunc', {
    value: function value(name, args) {
      return Array.prototype[name].apply(this, args);
    },
    enumerable: false,
    configurable: true,
    writable: false
  });
  Object.defineProperty(MyArray.prototype, 'copyWithin', {
    value: function value() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      if (!Array.prototype.copyWithin) {
        var target = args[0];

        if (target == null || +target !== target) {
          throw new TypeError('fist param of copyWithin must be number');
        }

        target = formatStart(target, this.length);
        var start = formatStart(args[1], this.length);
        var end = formatEnd(args[2], this.length);
        if (target == this.length) return this;
        var arr = this.slice(start, end);

        for (var i = 0; i < arr.length; i++) {
          if (target + i >= this.length) break;
          this[target + i] = arr[i];
        }

        return this;
      } else {
        return this.__nativeNewFunc('copyWithin', args);
      }
    },
    enumerable: false,
    configurable: true,
    writable: false
  });
  Object.defineProperty(MyArray.prototype, 'fill', {
    value: function value() {
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      if (!Array.prototype.fill) {
        var val = args[0];
        var start = formatStart(args[1], this.length);
        var end = formatEnd(args[2], this.length);

        for (var i = start; i < end; i++) {
          this[i] = val;
        }

        return this;
      } else {
        return this.__nativeFunc('fill', args);
      }
    },
    enumerable: false,
    configurable: true,
    writable: false
  });
  Object.defineProperty(MyArray.prototype, 'find', {
    value: function value() {
      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      if (!Array.prototype.find) {
        var func = args[0];

        if (typeof func != 'function') {
          throw new TypeError(args[0] + ' is not a function');
        }

        var res;

        for (var i = 0; i < this.length; i++) {
          if (func(this[i], i, this)) {
            res = this[i];
            break;
          }
        }

        return res;
      } else {
        return this.__nativeFunc('find', args);
      }
    },
    enumerable: false,
    configurable: true,
    writable: false
  });
  /**
   * 找到第一个匹配元素的下标
   * @param args
   */

  Object.defineProperty(MyArray.prototype, 'findIndex', {
    value: function value() {
      for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args[_key4] = arguments[_key4];
      }

      if (!Array.prototype.findIndex) {
        var func = args[0];

        if (typeof func != 'function') {
          throw new TypeError(func + ' is not a function');
        }

        var res = -1;

        for (var i = 0; i < this.length; i++) {
          if (func(this[i], i, this)) {
            res = i;
            break;
          }
        }

        return res;
      } else {
        return this.__nativeFunc('findIndex', args);
      }
    },
    enumerable: false,
    configurable: true,
    writable: false
  });
  /**
   * 从后往前遍历，找到最后一个匹配元素的下标
   * @param args
   */

  Object.defineProperty(MyArray.prototype, 'lastIndexOf', {
    value: function value() {
      for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
        args[_key5] = arguments[_key5];
      }

      if (!Array.prototype.lastIndexOf) {
        var searchElement = args[0];
        var fromIndex = args[2];

        if (+fromIndex !== fromIndex) {
          throw new TypeError(fromIndex + ' is not a number');
        }

        var len = this.length;

        if (fromIndex >= 0) {
          fromIndex = Math.min(len - 1, fromIndex);
        } else {
          fromIndex = len + fromIndex;
        }

        var res = -1;

        for (var i = fromIndex; i >= 0; i--) {
          if (this[i] === searchElement) {
            res = i;
            break;
          }
        }

        return res;
      } else {
        return this.__nativeFunc('lastIndexOf', args);
      }
    },
    enumerable: false,
    configurable: true,
    writable: false
  });
  Object.defineProperty(MyArray.prototype, 'reverse', {
    value: function value() {
      if (!Array.prototype.reverse) {
        var len = this.length;

        for (var i = 0; i < len - i; i++) {
          swithh(this, i, len - i);
        }

        return this;
      } else {
        this.__nativeFunc('reverse', []);

        return this;
      }
    },
    enumerable: false,
    configurable: true,
    writable: false
  });
  Object.defineProperty(MyArray.prototype, 'includes', {
    value: function value() {
      for (var _len6 = arguments.length, args = new Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
        args[_key6] = arguments[_key6];
      }

      if (!Array.prototype.includes) {
        var target = args[0];
        var fromIndex = args[1];
        var len = this.length;
        fromIndex = fromIndex >= 0 ? fromIndex : len + fromIndex;

        for (var i = fromIndex; i < len; i++) {
          if (this[i] === target) {
            return true;
          }
        }

        return false;
      } else {
        return this.__nativeFunc('includes', args);
      }
    },
    enumerable: false,
    configurable: true,
    writable: false
  });
  /**
   * 对于keys的调用是没有参数的，但是沙箱内部会传入一个当前环境的Symbol构造类进来。
   * @param Smbl
   */

  Object.defineProperty(MyArray.prototype, 'keys', {
    value: function value() {
      var Smbl = MyArray._Smbl;
      var len = this.length;
      var count = 0;
      return new Iterator_1.EIterator(Smbl, {
        next: function next() {
          if (count < len) {
            return {
              done: false,
              value: count++
            };
          } else {
            return {
              done: true,
              value: count
            };
          }
        }
      });
    },
    enumerable: false,
    configurable: true,
    writable: false
  });
  /**
   * 对于entries的调用是没有参数的，但是沙箱内部会传入一个当前环境的Symbol构造类进来。
   * @param Smbl
   */

  Object.defineProperty(MyArray.prototype, 'entries', {
    value: function value() {
      var Smbl = MyArray._Smbl;
      var arr = this.map(function (_) {
        return _;
      });
      var len = this.length;
      var count = 0;
      return new Iterator_1.EIterator(Smbl, {
        next: function next() {
          if (count < len) {
            return {
              done: false,
              value: [count, arr[count++]]
            };
          } else {
            return {
              done: true,
              value: null
            };
          }
        }
      });
    },
    enumerable: false,
    configurable: true,
    writable: false
  });
  Object.defineProperty(MyArray.prototype, 'values', {
    value: function value() {
      var Smbl = MyArray._Smbl;
      var arr = this.map(function (_) {
        return _;
      });
      var len = this.length;
      var count = 0;
      return new Iterator_1.EIterator(Smbl, {
        next: function next() {
          if (count < len) {
            return {
              done: false,
              value: arr[count++]
            };
          } else {
            return {
              done: true,
              value: null
            };
          }
        }
      });
    },
    enumerable: false,
    configurable: true,
    writable: false
  });
  Object.defineProperty(MyArray.prototype, 'flat', {
    value: function value() {
      for (var _len7 = arguments.length, args = new Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
        args[_key7] = arguments[_key7];
      }

      // @ts-ignore
      if (!Array.prototype.flat) {
        var depth = args[0];

        if (depth === undefined) {
          depth = 1;
        }

        if (+depth !== depth) {
          throw new TypeError('first parameter of Array.prototype.flat must be number');
        }

        var tt = new MyArray();
        var t = [].concat(flatten(this, depth));

        for (var i = 0; i < t.length; i++) {
          tt[i] = t[i];
        }

        return tt;
      } else {
        return this.__nativeNewFunc('flat', args);
      }
    },
    enumerable: false,
    configurable: true,
    writable: false
  });
  Object.defineProperty(MyArray.prototype, 'flatMap', {
    value: function value() {
      for (var _len8 = arguments.length, args = new Array(_len8), _key8 = 0; _key8 < _len8; _key8++) {
        args[_key8] = arguments[_key8];
      }

      // @ts-ignore
      if (!Array.prototype.flatMap) {
        var func = args[0];

        if (typeof func != 'function') {
          throw new TypeError('first parameter of Array.prototype.flatMap must be function');
        }

        var tt = new MyArray();
        var t = [].concat(flatten(this.map(func), 1));

        for (var i = 0; i < t.length; i++) {
          tt[i] = t[i];
        }

        return tt;
      } else {
        return this.__nativeNewFunc('flatMap', args);
      }
    },
    enumerable: false,
    configurable: true,
    writable: false
  });
  Object.defineProperty(MyArray.prototype, 'reduceRight', {
    value: function value() {
      for (var _len9 = arguments.length, args = new Array(_len9), _key9 = 0; _key9 < _len9; _key9++) {
        args[_key9] = arguments[_key9];
      }

      if (!Array.prototype.reduceRight) {
        var func = args[0];

        if (typeof func != 'function') {
          throw new TypeError('first parameter of Array.prototype.reduceRight must be function');
        }

        var initialValue = args[1];
        var startIndex = this.length - 1;

        if (initialValue === undefined) {
          if (this.length == 0) {
            throw new TypeError('calling reduceRight on an empty array without an initial value');
          }

          initialValue = this[this.length - 1];
          startIndex--;
        }

        for (var i = startIndex; i >= 0; i--) {
          initialValue = func(initialValue, this[i], i, this);
        }

        return initialValue;
      } else {
        return this.__nativeNewFunc('reduceRight', args);
      }
    },
    enumerable: false,
    configurable: true,
    writable: false
  }); // Object.defineProperty(MyArray.prototype, 'concat', {
  //     enumerable: false,
  //     value: function(...args) {
  //         return this.__nativeNewFunc('concat', args)
  //     }
  // })
  // protected pop(...args) {
  //     return this.__nativeFunc('pop', args)
  // }
  // protected push(...args) {
  //     return this.__nativeFunc('push', args)
  // }
  // protected slice(...args) {
  //     return this.__nativeNewFunc('slice', args)
  // }
  // protected shift() {
  //     return this.__nativeFunc('shift', [])
  // }
  // protected unshift() {
  //     return this.__nativeFunc('unshift', [])
  // }
  // protected sort(...args) {
  //     return this.__nativeFunc('sort', args)
  // }
  // protected splice(...args) {
  //     return this.__nativeFunc('splice', args)
  // }
  // protected indexOf(...args) {
  //     return this.__nativeFunc('indexOf', args)
  // }
  // protected join(...args) {
  //     return this.__nativeFunc('join', args)
  // }
  // protected forEach(...args) {
  //     return this.__nativeFunc('forEach', args)
  // }
  // protected filter(...args) {
  //     return this.__nativeFunc('filter', args)
  // }
  // protected map(...args) {
  //     return this.__nativeNewFunc('map', args)
  // }
  // protected every(...args) {
  //     return this.__nativeFunc('every', args)
  // }
  // protected some(...args) {
  //     return this.__nativeFunc('some', args)
  // }
  // protected reduce(...args) {
  //     return this.__nativeFunc('reduce', args)
  // }
  // protected toString() {
  //     return this.join(',')
  // }
  // protected toLocaleString() {
  //     return this.join(',')
  // }

  MyArray._setSmbl(Smbl);

  return MyArray;
}

exports.createArrayClass = createArrayClass;

function swithh(arr, i, j) {
  var t = arr[i];
  arr[i] = arr[j];
  arr[j] = t;
}

function flatten(array, depth) {
  var _iterator, _isArray, _i, _ref, item;

  return _regenerator.default.wrap(function flatten$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _iterator = array, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();

        case 1:
          if (!_isArray) {
            _context.next = 7;
            break;
          }

          if (!(_i >= _iterator.length)) {
            _context.next = 4;
            break;
          }

          return _context.abrupt("break", 20);

        case 4:
          _ref = _iterator[_i++];
          _context.next = 11;
          break;

        case 7:
          _i = _iterator.next();

          if (!_i.done) {
            _context.next = 10;
            break;
          }

          return _context.abrupt("break", 20);

        case 10:
          _ref = _i.value;

        case 11:
          item = _ref;

          if (!(Array.isArray(item) && depth > 0)) {
            _context.next = 16;
            break;
          }

          return _context.delegateYield(flatten(item, depth - 1), "t0", 14);

        case 14:
          _context.next = 18;
          break;

        case 16:
          _context.next = 18;
          return item;

        case 18:
          _context.next = 1;
          break;

        case 20:
        case "end":
          return _context.stop();
      }
    }
  }, _marked);
}

function formatStart(start, len) {
  if (+start !== start) {
    throw new TypeError('parameter must be number');
  }

  if (start == null) return 0;else if (start < 0) return Math.max(0, len + start);else return Math.min(len, start);
}

function formatEnd(end, len) {
  if (+end !== end) {
    throw new TypeError('parameter must be number');
  }

  if (end == null) return len;else if (end < 0) {
    return len + end < 0 ? len : len + end;
  } else return Math.min(len, end);
}
/**
 *  ["length", "constructor", "concat", "copyWithin", "fill", "find", "findIndex", "lastIndexOf", "pop", "push", "reverse", "shift", "unshift", "slice", "sort", "splice", "includes", "indexOf", "join", "keys", "entries", "values", "forEach", "filter", "flat", "flatMap", "map", "every", "some", "reduce", "reduceRight", "toLocaleString", "toString"]
 */