"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _construct2 = _interopRequireDefault(require("@babel/runtime/helpers/construct"));

Object.defineProperty(exports, "__esModule", {
  value: true
});

var Message_1 = require("../../Message");

var main_1 = require("../../../interpreter/main");

var util_1 = require("../../../util"); // new Ctrl()


function newExpressionHandler(node) {
  var _this = this;

  var source = this.source;
  var expression = this.createClosure(node.callee);
  var args = node.arguments.map(function (arg) {
    return _this.createClosure(arg);
  });
  return function () {
    var construct = expression();

    if (!util_1.isFunction(construct) || construct.__IS_EVAL_FUNC) {
      var callee = node.callee;
      var name = source.slice(callee.start, callee.end);
      throw _this.createInternalThrowError(Message_1.Messages.IsNotConstructor, name, node);
    } // new Function(...)


    if (construct.__IS_FUNCTION_FUNC) {
      return construct.apply(void 0, [new main_1.InternalInterpreterReflection(_this)].concat(args.map(function (arg) {
        return arg();
      })));
    }

    return (0, _construct2.default)(construct, args.map(function (arg) {
      return arg();
    }));
  };
}

exports.newExpressionHandler = newExpressionHandler;