"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Message_1 = require("../../Message");
// a==b a/b
function binaryExpressionHandler(node) {
    const leftExpression = this.createClosure(node.left);
    const rightExpression = this.createClosure(node.right);
    return () => {
        const leftValue = leftExpression();
        const rightValue = rightExpression();
        switch (node.operator) {
            case "==":
                return leftValue == rightValue;
            case "!=":
                return leftValue != rightValue;
            case "===":
                return leftValue === rightValue;
            case "!==":
                return leftValue !== rightValue;
            case "<":
                return leftValue < rightValue;
            case "<=":
                return leftValue <= rightValue;
            case ">":
                return leftValue > rightValue;
            case ">=":
                return leftValue >= rightValue;
            case "<<":
                return leftValue << rightValue;
            case ">>":
                return leftValue >> rightValue;
            case ">>>":
                return leftValue >>> rightValue;
            case "+":
                return leftValue + rightValue;
            case "-":
                return leftValue - rightValue;
            case "*":
                return leftValue * rightValue;
            case "**":
                return Math.pow(leftValue, rightValue);
            case "/":
                return leftValue / rightValue;
            case "%":
                return leftValue % rightValue;
            case "|":
                return leftValue | rightValue;
            case "^":
                return leftValue ^ rightValue;
            case "&":
                return leftValue & rightValue;
            case "in":
                return leftValue in rightValue;
            case "instanceof":
                return leftValue instanceof rightValue;
            default:
                throw this.createInternalThrowError(Message_1.Messages.BinaryOperatorSyntaxError, node.operator, node);
        }
    };
}
exports.binaryExpressionHandler = binaryExpressionHandler;
