"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Message_1 = require("../../Message");
// <App className="hello" />
// <App className={name} />
// <App show />
function JSXAttributeHandler(node) {
    if (node.name.type == 'JSXNamespacedName') {
        throw this.createInternalThrowError(Message_1.Messages.NormalError, 'JSXNamespacedName not support ', node);
    }
    let name = node.name.name;
    let valueClosure;
    if (!node.value) {
        valueClosure = () => true;
    }
    else if (node.value.type == 'JSXFragment') {
        throw this.createInternalThrowError(Message_1.Messages.NormalError, 'JSXFragment not support!', node);
    }
    else {
        valueClosure = this.createClosure(node.value);
    }
    return () => {
        return {
            [name]: valueClosure()
        };
    };
}
exports.JSXAttributeHandler = JSXAttributeHandler;
