"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Message_1 = require("../../Message");
const react_1 = require("../../Node/react");
// <div>hello</div>
function JSXElementHandler(node) {
    let React = this.globalContext['React'];
    if (!React) {
        throw this.createInternalThrowError(Message_1.Messages.NormalError, 'to use jsx, you must set React in globalContext', node);
    }
    let tag = node.openingElement.name;
    let tagClosure;
    if (tag.type == 'JSXIdentifier') {
        let tagname = tag.name;
        tagClosure = react_1.REACT_INTRINSIC_TAG.includes(tag.name) ?
            // 直接返回内置标签名
            () => tagname
            // 找到这个变量
            : this.createClosure({
                type: 'Identifier',
                name: tagname,
                loc: tag.loc,
            });
    }
    else if (tag.type == 'JSXMemberExpression') {
        // @ts-ignore
        tagClosure = this.createClosure(tag);
    }
    else if (tag.type == 'JSXNamespacedName') {
        throw this.createInternalThrowError(Message_1.Messages.NormalError, 'jsx namespacename not support. ', node);
    }
    let childrenClosure;
    if (node.openingElement.selfClosing || !node.children || !node.children.length) {
        childrenClosure = [() => null];
    }
    else {
        childrenClosure = node.children.map(item => {
            if (item.type == 'JSXElement') {
                return this.createClosure(item);
            }
            else if (item.type == 'JSXExpressionContainer') {
                return this.createClosure(item.expression);
            }
            else if (item.type == 'JSXText') {
                let val = item.value.trim();
                return () => val;
            }
            else {
                // fragment和spreadChild不支持
                return () => null;
            }
        });
    }
    let attrClosure;
    if (!node.openingElement.attributes || !node.openingElement.attributes.length) {
        attrClosure = [() => null];
    }
    else {
        attrClosure = node.openingElement.attributes.map(item => this.createClosure(item));
    }
    return () => {
        let tag = tagClosure();
        let attrs = attrClosure.map(_ => _()).filter(_ => _);
        let attr = attrs.length ? Object.assign.apply({}, attrs) : null;
        let childs = childrenClosure.map(_ => _()).filter(_ => _);
        return React.createElement(tag, attr, ...childs);
    };
}
exports.JSXElementHandler = JSXElementHandler;
