"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Message_1 = require("../../Message");
// a && b
function logicalExpressionHandler(node) {
    const leftExpression = this.createClosure(node.left);
    const rightExpression = this.createClosure(node.right);
    return () => {
        switch (node.operator) {
            case "||":
                return leftExpression() || rightExpression();
            case "&&":
                return leftExpression() && rightExpression();
            default:
                throw this.createInternalThrowError(Message_1.Messages.LogicalOperatorSyntaxError, node.operator, node);
        }
    };
}
exports.logicalExpressionHandler = logicalExpressionHandler;
