"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Message_1 = require("../../Message");
// [1,2,3]
function arrayExpressionHandler(node) {
    //fix: [,,,1,2]
    const items = node.elements.map(element => {
        if (!element)
            return null;
        return {
            type: element.type,
            // @ts-ignore
            closure: element.type == 'SpreadElement' ? this.createClosure(element.argument) : this.createClosure(element)
        };
    });
    return () => {
        const MArray = this.globalScope.data['Array'];
        const len = items.length;
        let result = new MArray;
        for (let i = 0; i < len; i++) {
            const item = items[i];
            if (!item) {
                result.push(undefined);
            }
            else {
                if (item.type == 'SpreadElement') {
                    let arr = item.closure();
                    if (!Array.isArray(arr)) {
                        throw this.createInternalThrowError(Message_1.Messages.NormalError, 'cannot spread, not an array type', node);
                    }
                    result = result.concat(arr);
                }
                else {
                    result.push(item.closure());
                }
            }
        }
        return result;
    };
}
exports.arrayExpressionHandler = arrayExpressionHandler;
