"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Symbols_1 = require("../../Symbols");
const Scope_1 = require("../../Scope");
// if(true){let i = 123;}else{}
function ifStatementHandler(node) {
    this.blockDeclareStart();
    const testClosure = this.createClosure(node.test);
    const consequentClosure = this.createClosure(node.consequent);
    const alternateClosure = node.alternate
        ? this.createClosure(node.alternate)
        : /*!important*/ () => Symbols_1.EmptyStatementReturn;
    let lexDeclared = this.blockDeclareEnd();
    return () => {
        let prevScope;
        let newScope;
        if (lexDeclared) {
            newScope = Scope_1.createScope(this.getCurrentScope(), `BScope(if)`, "block");
            newScope.lexDeclared = lexDeclared;
            prevScope = this.entryBlockScope(newScope);
        }
        let res = testClosure() ? consequentClosure() : alternateClosure();
        // 恢复
        if (lexDeclared) {
            this.setCurrentScope(prevScope);
        }
        return res;
    };
}
exports.ifStatementHandler = ifStatementHandler;
