"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Symbols_1 = require("../../Symbols");
const TokenClass_1 = require("../../TokenClass");
// label: xxx
function labeledStatementHandler(node) {
    const labelName = node.label.name;
    const bodyClosure = this.createClosure(node.body);
    return () => {
        let result;
        const currentScope = this.getCurrentScope();
        currentScope.labelStack.push(labelName);
        result = bodyClosure(node);
        // stop break label
        if (result instanceof TokenClass_1.BreakLabel && result.value === labelName) {
            result = Symbols_1.EmptyStatementReturn;
        }
        currentScope.labelStack.pop();
        return result;
    };
}
exports.labeledStatementHandler = labeledStatementHandler;
