"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Symbols_1 = require("../../Symbols");
// a.b a['b'] arr[1]
function memberExpressionHandler(node) {
    const objectGetter = this.createClosure(node.object);
    const keyGetter = this.createMemberKeyGetter(node);
    return () => {
        const MArray = this.globalScope.data['Array'];
        const obj = objectGetter();
        let key = keyGetter();
        if (Symbols_1.isSymbol(key)) {
            // 对于模拟的Symbol属性，实际存储在了一个特殊的key下面
            return obj[Symbols_1.storeKey(key)];
        }
        // arr[1]
        return obj[key];
    };
}
exports.memberExpressionHandler = memberExpressionHandler;
