"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Message_1 = require("../../Message");
const main_1 = require("../../../interpreter/main");
const util_1 = require("../../../util");
// new Ctrl()
function newExpressionHandler(node) {
    const source = this.source;
    const expression = this.createClosure(node.callee);
    const args = node.arguments.map(arg => this.createClosure(arg));
    return () => {
        const construct = expression();
        if (!util_1.isFunction(construct) || construct.__IS_EVAL_FUNC) {
            const callee = node.callee;
            const name = source.slice(callee.start, callee.end);
            throw this.createInternalThrowError(Message_1.Messages.IsNotConstructor, name, node);
        }
        // new Function(...)
        if (construct.__IS_FUNCTION_FUNC) {
            return construct(new main_1.InternalInterpreterReflection(this), ...args.map(arg => arg()));
        }
        return new construct(...args.map(arg => arg()));
    };
}
exports.newExpressionHandler = newExpressionHandler;
