"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Symbols_1 = require("../../Symbols");
const TokenClass_1 = require("../../TokenClass");
const Symbols_2 = require("../../Symbols");
const Scope_1 = require("../../Scope");
// {...}
function programHandler(node) {
    // const currentScope = this.getCurrentScope();
    // 记录当前块级作用域的所有词法变量的声明
    this.blockDeclareStart();
    // 块级作用域的handler初始化的时候就会遍历下级所有的body，创建closure，创建closure的时候就会完成变量声明提升的操作
    let stmtClosures = node.body.map((stmt) => {
        // if (stmt.type === "EmptyStatement") return null;
        return this.createClosure(stmt);
    });
    let functionDecl = node.body.map((_, index) => ({ type: _.type, index })).filter(_ => _.type == 'FunctionDeclaration');
    // 存放了块级作用域变量的列表
    let lexDeclared = this.blockDeclareEnd();
    return () => {
        let result = Symbols_1.EmptyStatementReturn;
        let prevScope;
        let newScope;
        if (lexDeclared) {
            newScope = Scope_1.createScope(this.getCurrentScope(), `BScope`, "block");
            newScope.lexDeclared = lexDeclared;
            prevScope = this.entryBlockScope(newScope);
        }
        // 如果有函数声明，先执行函数声明：
        functionDecl.forEach(_ => {
            stmtClosures[_.index]();
            // @ts-ignore
            stmtClosures[_.index] = null;
        });
        stmtClosures = stmtClosures.filter(_ => _);
        for (let i = 0; i < stmtClosures.length; i++) {
            const stmtClosure = stmtClosures[i];
            // save last value
            const ret = this.setValue(stmtClosure());
            // if (!stmtClosure) continue;
            // EmptyStatement
            if (ret === Symbols_1.EmptyStatementReturn)
                continue;
            result = ret;
            // BlockStatement: break label;  continue label; for(){ break ... }
            // ReturnStatement: return xx;
            if (result instanceof TokenClass_1.Return ||
                result instanceof TokenClass_1.BreakLabel ||
                result instanceof TokenClass_1.ContinueLabel ||
                result === Symbols_2.Break ||
                result === Symbols_2.Continue) {
                break;
            }
        }
        // 恢复
        if (lexDeclared) {
            this.setCurrentScope(prevScope);
        }
        // save last value
        return result;
    };
}
exports.programHandler = programHandler;
