"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Message_1 = require("../../Message");
// (...args)
function spreadElementHandler(node) {
    let closure = this.createClosure(node.argument);
    return () => {
        const data = closure();
        const MArray = this.globalScope.data['Array'];
        if (!Array.isArray(data)) {
            throw this.createInternalThrowError(Message_1.Messages.NormalError, `spread node type not array`, node);
        }
        return data;
    };
}
exports.spreadElementHandler = spreadElementHandler;
