"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getString(val) {
    if (typeof val === 'string') {
        return val;
    }
    else if (typeof val.toString === 'function') {
        return val.toString();
    }
    else {
        return Object.prototype.toString.call(val);
    }
}
// `hello ${estime}, test`
function templateLiteralHandler(node) {
    let vasGetters = node.expressions.map(_ => this.createClosure(_));
    let strs = node.quasis.map(_ => ({
        value: _.value,
        tail: _.tail,
    }));
    return () => {
        let str = '';
        for (let i = 0; i < strs.length; i++) {
            // use cooked or raw??
            str += (strs[i].value.cooked + (strs[i].tail ? '' : getString(vasGetters[i]())));
        }
        return str;
    };
}
exports.templateLiteralHandler = templateLiteralHandler;
