"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Message_1 = require("../../Message");
// ++a --a
function updateExpressionHandler(node) {
    const objectGetter = this.createLeftObjectGetter(node.argument);
    const nameGetter = this.createNameGetter(node.argument);
    return () => {
        const obj = objectGetter();
        const name = nameGetter();
        this.assertVariable(obj, name, node);
        switch (node.operator) {
            case "++":
                return node.prefix ? ++obj[name] : obj[name]++;
            case "--":
                return node.prefix ? --obj[name] : obj[name]--;
            default:
                throw this.createInternalThrowError(Message_1.Messages.UpdateOperatorSyntaxError, node.operator, node);
        }
    };
}
exports.updateExpressionHandler = updateExpressionHandler;
