"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Scope_1 = require("../../Scope");
const Symbols_1 = require("../../Symbols");
function withStatementHandler(node) {
    const objectClosure = this.createClosure(node.object);
    const bodyClosure = this.createClosure(node.body);
    return () => {
        const data = objectClosure();
        const currentScope = this.getCurrentScope();
        const newScope = new Scope_1.default(data, currentScope, Symbols_1.WithScopeName);
        // const data = objectClosure();
        // copy all properties
        // for (let k in data) {
        // 	newScope.data[k] = data[k];
        // }
        this.setCurrentScope(newScope);
        // save last value
        const result = this.setValue(bodyClosure());
        this.setCurrentScope(currentScope);
        return result;
    };
}
exports.withStatementHandler = withStatementHandler;
