"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function createSymbolFunc() {
    let cache = {};
    let count = {};
    function ESymbol(val) {
        if (this instanceof ESymbol) {
            throw new TypeError('cannot new a Symbol');
        }
        !count[val] && (count[val] = 0);
        count[val] += 1;
        return cache[val] ? new SymbolClass(val, { count }) : (cache[val] = new SymbolClass(val, { count }));
    }
    ESymbol.iterator = ESymbol('@@iterator');
    ESymbol.match = ESymbol('@@match');
    ESymbol.replace = ESymbol('@@replace');
    ESymbol.search = ESymbol('@@search');
    ESymbol.split = ESymbol('@@split');
    ESymbol.for = (val) => {
        return cache[val] || ESymbol(val);
    };
    ESymbol.keyFor = (t) => {
        if (t instanceof SymbolClass) {
            return t.val;
        }
        else {
            throw new TypeError('keyFor not a symbol');
        }
    };
    return ESymbol;
}
exports.createSymbolFunc = createSymbolFunc;
function isSymbol(t) {
    return typeof t == 'symbol' || t instanceof SymbolClass;
}
exports.isSymbol = isSymbol;
exports.memberKeyPrefix = '__smbl_';
function storeKey(t) {
    return `${exports.memberKeyPrefix}${t.offset}_${t.val}`;
}
exports.storeKey = storeKey;
class SymbolClass {
    constructor(val, env) {
        let count = env.count;
        this.val = val;
        // 附加一个偏移量，用于区别val一样的情形
        this.offset = count[val];
    }
}
// console.info好像不太管用
SymbolClass.prototype.toString = SymbolClass.prototype.valueOf = function () {
    return `Symbol(${this.val})`;
};
