"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const main_1 = require("./interpreter/main");
// TODO:
// add tests
function createContext(ctx = Object.create(null)) {
    return ctx;
}
exports.createContext = createContext;
function compileFunction(code, params = [], options = {}) {
    const ctx = options.parsingContext;
    const timeout = options.timeout === undefined ? 0 : options.timeout;
    const wrapCode = `
    (function anonymous(${params.join(",")}){
         ${code}
    });
    `;
    const interpreter = new main_1.Interpreter(ctx, {
        ecmaVersion: options.ecmaVersion,
        timeout,
        rootContext: options.rootContext,
        globalContextInFunction: options.globalContextInFunction,
    });
    return interpreter.evaluate(wrapCode);
}
exports.compileFunction = compileFunction;
function runInContext(code, ctx, options) {
    const interpreter = new main_1.Interpreter(ctx, options);
    return interpreter.evaluate(code);
}
exports.runInContext = runInContext;
exports.runInNewContext = runInContext;
class Script {
    constructor(code) {
        this._code = code;
    }
    runInContext(ctx) {
        return runInContext(this._code, ctx);
    }
    runInNewContext(ctx) {
        return runInContext(this._code, ctx);
    }
}
exports.Script = Script;
